#ifndef MSP_GLTK_RESOURCES_H_
#define MSP_GLTK_RESOURCES_H_

#include <msp/gl/font.h>
#include <msp/gl/texture.h>
#include <msp/datafile/collection.h>
#include <msp/datafile/directorysource.h>
#include <msp/fs/path.h>
#include "graphic.h"
#include "style.h"

namespace Msp {
namespace GLtk {

/**
Stores resources such as styles and graphics.  All widgets require a Resources
instance in constructor.
*/
class Resources: public DataFile::Collection
{
public:
	class Loader: public Collection::Loader
	{
	private:
		Resources &res;

	public:
		Loader(Resources &);
	private:
		void default_font(const std::string &);
		void font(const std::string &);
	};

private:
	FS::Path path;
	GL::Font *default_font;
	DataFile::DirectorySource *dir_src;

public:
	Resources();
	Resources(const FS::Path &);
private:
	void init();
public:
	~Resources();

	const GL::Font &get_default_font() const;

private:
	GL::Texture2D *create_texture(const std::string &);
};

} // namespace GLtk
} // namespace Msp

#endif
